import React, { Component } from 'react';
import { ItemInput } from './ItemInput';
import { TodoItem } from './todoItem';
import { TodoItems } from './TodoItems';

type TodoAppProps = {};
type TodoAppState = {
  items: Array<{ name: string, completed: boolean }>
};

export class TodoApp extends Component<TodoAppProps, TodoAppState> {

  constructor(props: TodoAppProps) {
    super(props);
    this.state = { items: [] };
  }

  render = (): JSX.Element => {
    return (
      <div>
        <h1>To-Do List</h1>
        <TodoItems items={this.state.items} onItemsChanged={this.doItemsChanged} />
        <ItemInput onAddClick={this.doAddClick} />
      </div>
    );
  }

  doAddClick = (item: TodoItem): void => {
    const items = this.state.items.concat([item]);
    this.setState({ items: items });
  }

  doItemsChanged = (newItems: Array<TodoItem>): void => {
    this.setState({ items: newItems });
  };
}
